
/***********************************************************************/
/*                                                                     */
/*                       BLACK2.C                                      */
/*                                                                     */
/*  A MODIFIED version of BLACK.EXE for use with the BLACKOUT screen   */
/*  saver by Staffan Ulfberg.  This module is for use with non-green   */
/*  monitors.  The code was modified so that when black.exe is called  */
/*  the full screen session will appear, no text will be printed, and  */
/*  the cursor will be hidden.  This has the effect of blacking out    */
/*  the screen.  I made this modification for my monitor (an old 14"   */
/*  Epson SVGA monitor).  I wanted a simple screen saver, but blackout */
/*  would not work with my monitor, since it is not a green monitor    */
/*  This module is uploaded w/ permission from Staffan, and there is a */
/*  possibility that the modification may be included in future        */
/*  versions of BLACKOUT.  Send any comments regarding my modification */
/*  of black.exe to djstauff@cs.twsu.edu.  All comments about the      */
/*  standard parts of BLACKOUT should be directed to Staffan's address */
/*  as given in the README file.                                       */             
/*                                                                     */
/*    I have taken the liberty of removing all of the code ported from */
/*  Linux by Staffan, since it is not used in this version of          */
/*  BLACK.EXE.  The only code left is Staffan's and mine -- so ignore  */
/*  the references below to other code and comments (because they have */
/*  been removed). However, pay attention to the part that says to use */
/*  this code at your own risk -- that still applies (pity we must     */
/*  always cover our hind ends all the time :-(  )                     */
/*                                                                     */
/*    The code should be compiled as BLACK2.EXE, and then all you      */
/*  need to do to use it is to copy BLACK2.EXE to BLACK.EXE in your    */
/*  BLACKOUT directory (or wherever you keep BLACKOUT).                */
/*                                                                     */
/*  Hope someone besides me finds this useful.                         */
/*                                                                     */
/*   D. J. Stauffer   ---  djstauff@cs.twsu.edu                        */
/*                                                                     */
/*                                                                     */
/***********************************************************************/



/*====================================================================
This file is part of the Blackout screen saver.       v0.92 1995-05-19
Copyright (C) 1995 by Staffan Ulfberg.    See README file for details.
====================================================================*/
/* This is the code that performs dpms blanking functions in Blackout.
   It was ported by Staffan Ulfberg from the console drivers in Linux
   on the 4th of April 1995.  You can see where the Linux people got
   the code from in the comments below.  The Linux code is almost
   unchanged, except for that I have added a main() function for use
   with Blankout.  All changes in the rest of the code are commented.
   You can search for "OS/2" to find the relevant changes.  I have
   also deleted a few include lines as well as a few external
   declarations.  Thanks to Henrik Storner for helping me find the
   original source code.

   And - just like the comments below say: You use this code at your
   own risk.  I take NO RESPONSIBILITY WHATSOEVER for damage caused by
   using the code below! */


/* -------------- ADDED WHEN PORTING THIS CODE TO OS/2 ------------- */
#define INCL_DOS
#define INCL_KBD
#define INCL_MOU
#define INCL_VIO
#define INCL_WINSWITCHLIST
#include <stdlib.h>
#include <stdio.h>
#include <os2.h>
#include <string.h>
#define cli()
#define sti()

/* #define DEBUG */

HEV hevSuspend, hevOff;

int main(int argc, char *argv[]) {
  USHORT rc, mask = 126;
  UCHAR status;
  HMOU hmou;

/***********************************************************************/
/*                                                                     */
/*  Beginning of the portion of code provided by D. J. Stauffer...     */
/*                                                                     */
/***********************************************************************/
  
  
  VIOCURSORINFO CursorData;
  PVIOCURSORINFO PCursorData;

  CursorData.yStart =0;
  CursorData.cEnd =0;  
  CursorData.cx =0;
  CursorData.attr =-1;  

  PCursorData = &CursorData;
  
  VioSetCurType(PCursorData, 0);
  
/***********************************************************************/
/*                                                                     */
/*    End of code provided by D. J. Stauffer, other portions of the    */
/*  original code have been removed below and above this section to    */
/*  provide the desired functionality, and to remove code not          */
/*  necessary for the desired functionality.                           */
/*                                                                     */
/***********************************************************************/

  if (argc != 2 || strcmp(argv[1], "0") && strcmp(argv[1], "1")) {
    printf("Usage: %s mouse.\n", argv[0]);
    printf("\nmouse is '0' or '1' for mouse move sensing off or on.\n");
    sleep(5);
    exit(1);
  }
  if (rc = DosOpenEventSem("\\SEM32\\BLACKOUT\\SUSPEND", &hevSuspend)) {
    printf("DosOpenEventSem(Suspend): %d\nBlackout is not running?\n", rc);
    sleep(5);
    exit(3);
  }
  if (rc = DosOpenEventSem("\\SEM32\\BLACKOUT\\OFF", &hevOff)) {
    printf("DosOpenEventSem(Off): %d\nBlackout is not running?\n", rc);
    sleep(5);
    exit(5);
  }
  MouOpen(NULL, &hmou);
  if (*argv[1] == '0')
    MouSetEventMask(&mask, hmou);

  sleep(2);
  VioScrLock(0, &status, 0);
  if (status) {
    printf("Can't lock screen!\n");
    sleep(5);
    exit(4);
  }

  DosWaitEventSem(hevSuspend, (ULONG)SEM_INDEFINITE_WAIT);
  DosWaitEventSem(hevOff, (ULONG)SEM_INDEFINITE_WAIT);

  VioScrUnLock(0);
  MouClose(hmou);
  return 0;
}

